api/urls.py
from django.urls import include, re_path

urlpatterns = [
    # global
    re_path(r'^', include('api.global.urls')),
    # v1
    re_path(r'^v1/accounts/', include('api.v1.accounts.urls')),
    re_path(r'^v1/ticket/', include('api.v1.ticket.urls')),
    re_path(r'^v1/faq/', include('api.v1.faq.urls')),
    re_path(r'^v1/knowledges_base/', include('api.v1.knowledgebase.urls')),
    re_path(r'^v1/article/', include('api.v1.article.urls')),
    re_path(r'^v1/project/', include('api.v1.project.urls')),
    re_path(r'^v1/blog/', include('api.v1.blog.urls')),

    # v2

]

dashboard/urls.py
from django.urls import path, re_path, include
from . import views
from ticket.views import TicketCreateView
from ticket.views import TicketDetailView
from project.views import ProjectView
from project.views import ProjectTemplateView
from project.views import ProjectFinalizeView
from project.views import ProjectShownView

from django.views.decorators.cache import cache_page


app_name = 'dashboard'
urlpatterns = [
    re_path(r'^$', views.HomeView.as_view(), name='home'),
    re_path(r'^account/$', views.AccountView.as_view(), name='account'),
    re_path(r'^account/team/list/$', views.TeamView.as_view(), name='project-team-list'),
    
    re_path(r'^account/profile/(?P<sku_app>\w+\d*)/$', views.AccountProfileUpdateView.as_view(), name='account-profile-edit'),
    re_path(r'^account/profile/(?P<sku_app>\w+\d*)/published/$', views.AccountProfileFinalizeView.as_view(), name='account-profile-published'),
    # cached
    re_path(r'^account/applications/$', views.ApplicationListView.as_view(), name='application-list'),

    re_path(r'^account/application/(?P<pk>\d+)/create/$', views.ApplicationCreateView.as_view(), name='application-create'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/published/$', views.ApplicationFinalizeView.as_view(), name='application-published'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/$', views.ApplicationView.as_view(), name='application-edit'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/$', ProjectView.as_view(), name='application-project-edit'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/shown/$', ProjectShownView.as_view(), name='application-project-shown'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/preview/$', ProjectTemplateView.as_view(), name='project-view'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/published/$', ProjectFinalizeView.as_view(), name='application-project-published'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/team/members/$', views.TeamMemberView.as_view(), name = 'project-team-member'),
    re_path(r'^account/application/(?P<sku>\w+\d*)/project/(?P<sku_project>\w+\d*)/team/published/$', views.TeamPublishedView.as_view(), name = 'project-team-published'),
    # cached
    re_path(r'^knowledge-base/$', cache_page(60*15)(views.KnowledgeBaseView.as_view()), name='knowledge-base'),
    re_path(r'^privacy-policy/$', cache_page(60*15)(views.PrivacyPolicyView.as_view()), name='privacy-policy'),
    re_path(r'^faq/$', cache_page(60*15)(views.FAQView.as_view()), name='faq'),
    
    re_path(r'^ticket/$', TicketCreateView.as_view(), name='ticket-create'),
    re_path(r'^ticket/(?P<sku>\w+)/$', TicketDetailView.as_view(), name='ticket-detail'),  
]

dashboard/models.py
from django.db import models

dashboard/views.py
from django.contrib.auth.models import User
from django.views.generic import TemplateView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.cache import cache

from pages.models import Site

from accounts.models import (
    Application,
    Profile
)
from project.models import Project
from ticket.models import Ticket
from step.models import Step

from dashboard.subviews.application import (
    ApplicationListView,
    ApplicationCreateView,
    ApplicationFinalizeView,
    ApplicationView,
)

from dashboard.subviews.pages import(
    KnowledgeBaseView,
    FAQView,
    PrivacyPolicyView,
    ResponsiblityView,
    MemberView,
    TeamView,
    ExperienceView,
)

from dashboard.subviews.profile import (
    AccountView,
    AccountProfileFinalizeView,
    AccountProfileUpdateView,
)

from dashboard.subviews.team import(
    TeamMemberView,
    TeamPublishedView
)

class HomeView(LoginRequiredMixin, TemplateView):
    template_name = "dashboard/pages/home.html"
    page_name = 'Dashboard'


    def get_application_status(self, app):

        steps = Step.objects.filter(application = app)
        # import pdb ; pdb.set_trace()
        count = Step.objects.filter(application = app, state = 't').count()

        if count == 5:

            return False

        for step in steps:

            if step.state == 'i' : return False

        return True


    def get_profile_status(self):

        step = Step.objects.filter(user = self.request.user, step = '1', state = 'i')

        return False if step else True


    def get_requests_status_objects(self, type):

        apps = Application.objects.filter(user = self.request.user)

        step = Step.objects.filter(user = self.request.user, step = '1', state = 'i')

        if type == 'inprogress':

            inprogress = list()
            
            inprogress_count = 0

            for app in apps:

                if not self.get_application_status(app):
                    
                    inprogress_count += 1

                    inprogress.append(app)

            if step:

                inprogress_count += 1
            
            return dict([('count', inprogress_count), ('inprogress', inprogress)])
        
        if type == 'complete':

            complete = list()

            complete_count = 0

            for app in apps:

                if self.get_application_status(app):
                    
                    complete_count += 1

                    complete.append(app)

            if not step:

                complete_count += 1

            return dict([('count', complete_count), ('complete', complete)])


    def get_number_of_complete_step_application(self):

        apps = Application.objects.filter(user = self.request.user)

        count = Application.objects.filter(user = self.request.user).count()
        
        complete = 0

        for app in apps:
            
            step = Step.objects.filter(application = app, state = 'c', step = '2').exists()


            if step:
                complete = complete + 1
        
        
        result = (complete / count) * 100
        return result, complete, count 


    def get_number_of_complete_step_project(self):

        apps = Application.objects.filter(user = self.request.user)

        count = Project.objects.filter(application__in = apps).count()
        complete = 0
        for app in apps:

            project = Project.objects.filter(application = app)

            if project:

                step = Step.objects.filter(application = app, state = 'c', step = '3')

                if step: complete += 1

            else:

                continue
        
        try:
            result = (complete / count) * 100
        except:
            result = 0

        return result, complete, count 


    def project_status(self, project):

        project_progress_num = 15

        attrs = vars(project)

        for key in attrs.keys():
            if key in ['is_published',
                       'is_shown',
                       'title',
                       'summary',
                       'problem',
                       'solution',
                       'product',
                       'customer',
                       'business',
                       'market',
                       'competition',
                       'vision',
                       'founders',
                       'cover', 'video']:
                if not attrs[key]:
                    project_progress_num -= 1
            else:
                continue

        percent_complete_of_project = (project_progress_num / 15) * 100
      
        return (attrs['sku'], percent_complete_of_project)


    def application_status(self, app):

        attrs = vars(app)

        extra_field = ['_state', 'id', 'sku', 'user_id',
                       'created', 'modified', 'webiste',
                       'is_b2b', 'is_b2c', 'is_b2g', 'is_b2b2c',
                       'has_product', 'qatari_partnership', 'sales_rate', 'sales_rate_type']

        if attrs['qatari_partnership']:

            application_progress_num = 11

        else:

            application_progress_num = 7

            extra_field.extend(['kafil_fname', 'kafil_lname', 'kafil_email', 'kafil_qatari_id'])

        total = application_progress_num

        if not (attrs['is_b2b'] or attrs['is_b2c'] or attrs['is_b2g'] or attrs['is_b2b2c']):

            application_progress_num -= 1

        for key in attrs.keys():
            if key in extra_field:
                continue
            else:
                if not attrs[key]:
                    application_progress_num -= 1

        percent_complete_of_application = (application_progress_num / total) * 100

        return (attrs['sku'], percent_complete_of_application)
    

    def whole_process(self, app):
        result = (Step.objects.filter(application = app, state = 'c').count() / 5) * 100
        return app.sku, result
    
    
    def get_context_data(self, **kwargs):

        context = super().get_context_data(**kwargs)

        profile = Profile.objects.get(user = self.request.user)
        
        profile_progress_num = 13
        attrs = vars(profile)
        for key, value in attrs.items():
            if key in ['_state', 'id', 'user_id', 'width_field', 'height_field', 'width_field_pic', 'height_field_pic', 'email_confirmed', 'modified', 'is_shown']:
                continue
            else:
                if not attrs[key]:
                    profile_progress_num -= 1
       
        
        context['profile_progress'] = (profile_progress_num / 13) * 100
        context['profile_progress_num'] = profile_progress_num
        context['profile_status'] = self.get_profile_status() # if Flase: profile is inprogress, if True: profile is complete

        context['site'] = Site.objects.first()
    
        context["ticket_count"] = Ticket.objects.filter(raised_by = self.request.user.pk).count()
        context["tickets"] = Ticket.objects.filter(raised_by = self.request.user.pk)

        context["answered_ticket_count"] = Ticket.objects.filter(raised_by = self.request.user.pk,
                                                                 answer_status = 'a'
                                                                ).count()

        context["unanswered_ticket_count"] = Ticket.objects.filter(raised_by = self.request.user.pk,
                                                                 answer_status = 'u'
                                                                ).count()

        apps = Application.objects.filter(user = self.request.user)

        context["project_count"] = Project.objects.filter(application__in = apps).count()

        context["projects"] = Project.objects.filter(application__in = apps)
        context["apps"] = apps

        inprogress = self.get_requests_status_objects('inprogress')
        context["inprogress_requests_count"] = inprogress['count'] # number of inprogress requests
        context["inprogress_requests"] = inprogress['inprogress']  # list of inprogress requests

        complete = self.get_requests_status_objects('complete')
        context["complete_requests_count"] = complete['count'] # number of complete requests
        context["complete_requests"] = complete['complete'] # list of complete requests

        # import pdb ; pdb.set_trace()
        complete_applications_progress, complete_applications_current, complete_applications_total  = self.get_number_of_complete_step_application()
        context['complete_applications_progress'] = complete_applications_progress
        context['complete_applications_total'] = complete_applications_total
        context['complete_applications_current'] = complete_applications_current

        complete_project_progress, complete_project_current, complete_project_total  = self.get_number_of_complete_step_project()
        context['complete_project_progress'] = complete_project_progress
        context['complete_project_total'] = complete_project_total
        context['complete_project_current'] =  complete_project_current


        context['applications_status'] = list(map(lambda app: self.application_status(app), apps))
        # import pdb ; pdb.set_trace()
        projects = Project.objects.filter(application__in = apps)
        
        context['projects_status'] = list(map(lambda app: self.project_status(app), projects))
        
        context['whole_process'] = list(map(lambda app: self.whole_process(app), apps))
        
        return context

# Modularity Views checked
# Team Form UI
# Team Form Backend
# Team database submission
# Profile ?

# Test Project hich moshkeli nadashte

media/templates/dashboard/partials/footer.html
{% if view.remove_footer %}
    
{% else %}
    <footer class="page-footer">
        <div class="footer-content">
            <div class="container-fluid">
                <div class="row">
                    <div class="col-12 col-sm-6">
                        <p class="mb-0 text-muted">Deneb 2020</p>
                    </div>
                    <div class="col-sm-6 d-none d-sm-block">
                        <ul class="breadcrumb pt-0 pr-0 float-right">
                            <li class="breadcrumb-item mb-0">
                                <a href="{% url 'dashboard:privacy-policy' %}" class="btn-link">Privacy Policy</a>
                            </li>
                            <li class="breadcrumb-item mb-0">
                                <a href="{% url 'dashboard:faq' %}" class="btn-link">FAQ</a>
                            </li>
                            <li class="breadcrumb-item mb-0">
                                <a href="{% url 'dashboard:knowledge-base' %}" class="btn-link">Knowledge Base</a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </footer>
{% endif %}

media/templates/dashboard/partials/modal-yesno.html
<div class="container">
    <div class="modal fade" id="check" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Warning</h4>
                </div>
                <div class="modal-body">
                    {% if user.profile.is_published %}
                        <p id="body-messaage">After finalizing your application you can not modify your application anymore. Are you sure to finalize application?</p>
                    {% else %}
                        <p id="body-messaage">Application is not available when you didn't complete your profile. Please visit profile link and finalize your profile.</p>
                    {% endif %}
                </div>

                {% if request.user.profile.is_published %}
                    <div class="modal-footer">
                        <form method="POST" action="{% url 'dashboard:application-create' request.user.pk %}">
                            {% csrf_token %}
                            <button style="float: right;" type="submit" class="btn btn-info">Yes</button>
                        </form>
                        <button style="float: right;" class="btn btn-danger" data-dismiss="modal">No</button>
                    </div>
                {% else %}
                    <div class="modal-footer">
                        <a href="{% url 'dashboard:account-profile-edit' user.pk %}" style="float: right;" type="submit" class="btn btn-info">Profile Section</a>
                        <button style="float: right;" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                    </div>
                {% endif %}
            </div>
        </div>
    </div>

    <div class="modal fade" id="projectModal" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Information</h4>
                </div>
                <div class="modal-body">
                    
                    <p>First you must finalize your application.</p>
                </div>

                <div class="modal-footer">
                    <button style="float: right;" class="btn btn-danger" data-dismiss="modal">No</button>
                </div>
            </div>
        </div>
    </div>
</div>

media/templates/dashboard/partials/recaptcha.html
<script src="https://www.google.com/recaptcha/api.js?render=6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A"></script>
  <script>
    grecaptcha.ready(function() {
        $('#captchaForm').submit(function(e){
            var form = this;
            e.preventDefault()
            grecaptcha.execute('6LfZsvgUAAAAAJX02IjM58aIqO5y-g60SRJGPR4A', {action: 'recaptcha'}).then(function(token) {
                $('#recaptcha').val(token)
                form.submit()
            });
        })

    });
</script>

media/templates/dashboard/partials/side-nav.html
{% load static %}
{% load cache %}

{% cache 500 sidenav view.page_name %}
<div class="menu">
    <div class="main-menu">
        <div class="scroll">
            <ul class="list-unstyled">
                <li {% if view.page_name == 'Dashboard' %}class="active"{% endif %}>
                    <a href="{% url 'dashboard:home'  %}">
                        <img style="width: 30px;" src="{% static 'assets/images/logos/Orange-home-icon.png' %}" alt="">
                        <span>Dashboard</span>
                    </a>
                </li>
                <li {% if view.page_name == 'Application' %}class="active"{% endif %}>
                    <a href="{% url 'dashboard:application-list' %}">
                        <i class="simple-icon-chemistry"></i> Applications
                    </a>
                </li>

                <li {% if view.page_name == 'Ticket' %}class="active"{% endif %}>
                    <a href="{% url 'dashboard:ticket-create' %}">
                        <i class="iconsminds-pantone"></i> Tickets
                    </a>
                </li>
                <li {% if view.page_name == 'Knowledge Base' %}class="active"{% endif %}>
                    <a href="{% url 'dashboard:knowledge-base' %}">
                        <i class="simple-icon-graduation"></i> Knowledge Base
                    </a>
                </li>
                <li {% if view.page_name == 'FAQ' %}class="active"{% endif %}>
                    <a href="{% url 'dashboard:faq' %}">
                        <i class="simple-icon-question"></i> FAQ
                    </a>
                </li>
            </ul>
        </div>
    </div>
</div>
{% endcache %}

media/templates/dashboard/partials/top-nav.html
{% load static %}

{% load cache %}

{% cache 500 topnav request.user %}
<nav class="navbar fixed-top">
    <div class="d-flex align-items-center navbar-left">
        <a href="#" class="menu-button d-none d-md-block">
            <svg class="main" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 9 17">
                <rect x="0.48" y="0.5" width="7" height="1" />
                <rect x="0.48" y="7.5" width="7" height="1" />
                <rect x="0.48" y="15.5" width="7" height="1" />
            </svg>
            <svg class="sub" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 18 17">
                <rect x="1.56" y="0.5" width="16" height="1" />
                <rect x="1.56" y="7.5" width="16" height="1" />
                <rect x="1.56" y="15.5" width="16" height="1" />
            </svg>
        </a>

        <a href="#" class="menu-button-mobile d-xs-block d-sm-block d-md-none">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 26 17">
                <rect x="0.5" y="0.5" width="25" height="1" />
                <rect x="0.5" y="7.5" width="25" height="1" />
                <rect x="0.5" y="15.5" width="25" height="1" />
            </svg>
        </a>

    </div>


    <a class="navbar-logo" href="{% url 'dashboard:home' %}">
        <span class="logo d-none d-xs-block"></span>
        <span class="logo-mobile d-block d-xs-none"></span>
    </a>

    <div class="navbar-right">
        <div class="header-icons d-inline-block align-middle">
            <div class="d-none d-md-inline-block align-text-bottom mr-3">
                <div class="custom-switch custom-switch-primary-inverse custom-switch-small pl-1" 
                    data-toggle="tooltip" data-placement="left" title="Dark Mode">
                    <input class="custom-switch-input" id="switchDark" type="checkbox" checked>
                    <label class="custom-switch-btn" for="switchDark"></label>
                </div>
            </div>

            

            <button class="header-icon btn btn-empty d-none d-sm-inline-block" type="button" id="fullScreenButton">
                <i class="simple-icon-size-fullscreen"></i>
                <i class="simple-icon-size-actual"></i>
            </button>

        </div>

        <div class="user d-inline-block">
            <button class="btn btn-empty p-0" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <span class="name">{{ user.username }}</span>
                <span>
                    <img src="{% if user.profile.picture %}{{ user.profile.picture.url }}{% else %}https://via.placeholder.com/1000{% endif %}" alt="{{ user.first_name }} {{ user.last_name }}" />
                </span>
            </button>

            <div class="dropdown-menu dropdown-menu-right mt-3">
                <a class="dropdown-item" href="{% url 'dashboard:privacy-policy' %}">Privacy Policy</a>
                <a class="dropdown-item" href="{% url 'dashboard:ticket-create' %}">Support</a>
                <a class="dropdown-item" href="{% url 'logout' %}">Sign out</a>
            </div>
        </div>
    </div>
</nav>
{% endcache %}